DEFINT A-Z
$CODE SEG "XGraf V1.00"

TYPE pcx
  password AS STRING * 1
  version  AS STRING * 1
  encoding AS STRING * 1
  bits     AS STRING * 1
  xmin     AS INTEGER
  ymin     AS INTEGER
  xmax     AS INTEGER
  ymax     AS INTEGER
  xres     AS INTEGER
  yres     AS INTEGER
  pal      AS STRING * 48
  reserved AS STRING * 1
  planes   AS STRING * 1
  bytes    AS INTEGER
  paltyp   AS INTEGER
  filler   AS STRING * 58
END TYPE

' PCX-Viewer V1.80 Robert Seidel 07.05.94 - 30.01.1995

' Einer der schnellsten, mir bekannten PCX-Viewer !
' PCXFAST8 entstand aus einem schnellen C- und einem
' sehr sehr langsamen PB-Viewer.
' Dieses Programm arbeitet jetzt sogar etwas schneller
' als der C-Viewer.
' Das Programm ist gegenber der Urversion von PCXFAST
' rund 58mal schneller !
' Es beinhaltet alle Tricks, die das C-Programm verwendete
' und einige nderungen, da einige Kommandos in
' PowerBASIC (dem besten Basiccompiler der Welt) fehlen.

' Dies ist eine Version fr die Copy-Station des
' Ernst-Haeckel-Gymnasiums 11 M 1 - Informatik bei M. Mller

' Jetzt mit x/y-Koordinate !

DIM filebuffer AS SHARED STRING
SHARED zchn? , index% , pt% , sg% , file%

'its my old PCX-routine, I am working on a new one,
'without the string-problem caused by PB and including
'more ASM

'it puts a PCX on x% and y%, destroys the old pal and
'it doesn't care if the file exists -> be careful !!!

SUB PutPCXXY(x% , y% , filename$) PUBLIC

file% = FREEFILE

DIM pcxheader AS pcx

 OPEN filename$ FOR INPUT AS #file%          'testet ob File da
 CLOSE #file%
 OPEN filename$ FOR BINARY AS #file%

 GET #file%, 0, pcxheader                    'lese PCX-Header

 GetPal256
 index% = 0

 SEEK #file% , 128
 GET$ #file% , 32750 , filebuffer

 sg% = STRSEG(filebuffer)
 pt% = STRPTR(filebuffer)

FOR row% = x% TO (pcxheader.ymax - pcxheader.ymin) + x%
  col% = y%
  DEF SEG = sg%
  WHILE col% < pcxheader.bytes + x%
  NextChar
    IF zchn? > &HC0 THEN                ' testet ob komprimiert
      pass? = zchn? AND &h3F            ' JA, wieviele Zeichen ?
      NextChar
        ! MOV AX , 320          ; KOORDINATEN-BERECHNUNG
        ! MUL row%
        ! MOV DI , AX           ; Formel : 320 * y + x
        ! ADD DI , col%         ; fr Offset
        ! MOV DX , &hA000       ; Segment : A000h (Videospeicher)
        ! MOV ES , DX
        ! MOV AL , zchn?        ; Farbe
        ! MOV CX , pass?        ; Anzahl der Punkte
        ! REP STOSB
      col% = col% + pass?
    ELSE
        ! MOV AX , 320
        ! MUL row%
        ! MOV DI , AX
        ! ADD DI , col%
        ! MOV DX , &hA000
        ! MOV ES , DX
        ! MOV AL , zchn?
        ! STOSB
      INCR col%
    END IF
  WEND

NEXT row%

CLOSE file%

END SUB

SUB nextchar
  zchn? = PEEK(pt% + index%)        ' Programm arbeitet schneller
  INCR index%                       ' mit PEEK als mit PEEK$ !!!
   IF index% = 32750 THEN
      GET$ #file% , 32750 , filebuffer
      index% = 0
      pt% = STRPTR(filebuffer)
      sg% = STRSEG(filebuffer)
      DEF SEG = sg%
   END IF
END SUB

SUB GetPal256
  DIM pal256 AS SHARED STRING
    SEEK #file% , LOF(1) - 769
    GET$ #file% , 1 , test$      'testet ob 256 Farben
    IF ASC(test$) = &h0C THEN
      GET$ #file% , 768 , pal256
      DEF SEG = STRSEG(pal256)
      index% = STRPTR(pal256)
      FOR i% = 0 TO 765 STEP 3
        r% = PEEK(index% + i%) \ 4
        g% = PEEK(index% + i% + 1) \ 4
        b% = PEEK(index% + i% + 2) \ 4
        CALL SetRGB(num% , r% , g% , b%)
        INCR num%
      NEXT
    END IF
    Ver$ = "XGraf V1.00 by Robert Seidel 95"
END SUB